diff --git a/src/gui/TagEditor.cpp b/src/gui/TagEditor.cpp
index 68790595..3749fbc6 100644
--- a/src/gui/TagEditor.cpp
+++ b/src/gui/TagEditor.cpp
@@ -98,6 +98,7 @@ static inline Ogg::XiphComment *getXiphComment(File &file)
 #include <QBoxLayout>
 #include <QLineEdit>
 #include <QMimeData>
+#include <QUrl>
 #include <QSpinBox>
 #include <QPainter>
 #include <qevent.h>
@@ -201,12 +202,10 @@ TagEditor::TagEditor() :
     saveImgB = new QPushButton(tr("Save cover picture"));
     saveImgB->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
 
-    connect(pictureW, &PictureW::loadImage, this, &TagEditor::loadImage);
+    connect(pictureW, SIGNAL(loadImage(const QString &)), this, SLOT(loadImage(const QString &)));
 
-    connect(loadImgB, &QPushButton::clicked, this, [this] {
-        loadImage(QString());
-    });
-    connect(saveImgB, &QPushButton::clicked, this, &TagEditor::saveImage);
+    connect(loadImgB, SIGNAL(clicked()), this, SLOT(handleLoadImageClicked()));
+    connect(saveImgB, SIGNAL(clicked()), this, SLOT(saveImage()));
 
     QVBoxLayout *pictureLayout = new QVBoxLayout(pictureB);
     pictureLayout->addWidget(pictureW);
@@ -665,3 +664,9 @@ void TagEditor::clearValues()
     pictureB->setChecked(false);
     pictureB->setEnabled(false);
 }
+
+// Qt4: Helper slot implementation
+void TagEditor::handleLoadImageClicked()
+{
+    loadImage(QString());
+}
diff --git a/src/gui/TagEditor.hpp b/src/gui/TagEditor.hpp
index d63af76e..c1569343 100644
--- a/src/gui/TagEditor.hpp
+++ b/src/gui/TagEditor.hpp
@@ -31,7 +31,7 @@ class QMimeData;
 class QSpinBox;
 class QLabel;
 
-class PictureW final : public QWidget
+class PictureW : public QWidget
 {
     Q_OBJECT
 
@@ -42,10 +42,10 @@ private:
     bool verifyMimeData(const QMimeData *m) const;
 
 private:
-    void paintEvent(QPaintEvent *) override;
+    void paintEvent(QPaintEvent *);
 
-    void dragEnterEvent(QDragEnterEvent *e) override;
-    void dropEvent(QDropEvent *e) override;
+    void dragEnterEvent(QDragEnterEvent *e);
+    void dropEvent(QDropEvent *e);
 
 signals:
     void loadImage(const QString &filePath);
@@ -65,9 +65,11 @@ public:
     void clear();
     bool save();
 
-private:
+private slots:
     void loadImage(QString filePath);
     void saveImage();
+    // Qt4: Helper slot for lambda conversion
+    void handleLoadImageClicked();
 
 private:
     void clearValues();
diff --git a/src/gui/Unix/ScreenSaver.cpp b/src/gui/Unix/ScreenSaver.cpp
index 8953f8ed..660c8ead 100644
--- a/src/gui/Unix/ScreenSaver.cpp
+++ b/src/gui/Unix/ScreenSaver.cpp
@@ -18,7 +18,6 @@
 
 #include <ScreenSaver.hpp>
 
-#include <QGuiApplication>
 #include <QLibrary>
 
 #ifdef DBUS_PM
@@ -41,13 +40,13 @@ public:
     ScreenSaverPrivX11() :
         m_disp(nullptr)
     {}
-    ~ScreenSaverPrivX11() override
+    ~ScreenSaverPrivX11()
     {
         if (m_disp)
             XCloseDisplayFunc(m_disp);
     }
 
-    bool load() override
+    bool load()
     {
         QLibrary libX11("libX11.so.6");
         if (libX11.load())
@@ -66,18 +65,18 @@ public:
         return false;
     }
 
-    void inhibit() override
+    void inhibit()
     {
         timerEvent(nullptr);
         m_timerID = startTimer(30000);
     }
-    void unInhibit() override
+    void unInhibit()
     {
         killTimer(m_timerID);
     }
 
 private:
-    void timerEvent(QTimerEvent *) override
+    void timerEvent(QTimerEvent *)
     {
         XForceScreenSaverFunc(m_disp, 0);
         XFlushFunc(m_disp);
@@ -106,23 +105,23 @@ public:
     ScreenSaverPrivDBus()
         : m_iface("org.freedesktop.ScreenSaver", "/org/freedesktop/ScreenSaver", "org.freedesktop.ScreenSaver")
     {}
-    ~ScreenSaverPrivDBus() override
+    ~ScreenSaverPrivDBus()
     {
     }
 
-    bool load() override
+    bool load()
     {
         return !m_iface.lastError().isValid();
     }
 
-    void inhibit() override
+    void inhibit()
     {
         bool ok = false;
         quint32 cookie = m_iface.call("Inhibit", QCoreApplication::applicationName(), "Playback").arguments().value(0).toUInt(&ok);
         if (ok)
             m_cookie = cookie;
     }
-    void unInhibit() override
+    void unInhibit()
     {
         if (Q_UNLIKELY(m_cookie == 0))
             return;
@@ -151,15 +150,15 @@ ScreenSaver::ScreenSaver()
     m_priv = nullptr;
 #endif
 
-    if (QGuiApplication::platformName() != "xcb")
-        return;
-
+    // Qt4: Use Q_WS_X11 instead of platformName check
+#ifdef Q_WS_X11
     m_priv = new ScreenSaverPrivX11;
     if (m_priv->load())
         return;
 
     delete m_priv;
     m_priv = nullptr;
+#endif
 }
 ScreenSaver::~ScreenSaver()
 {
diff --git a/src/gui/Updater.hpp b/src/gui/Updater.hpp
index 185420cf..4a55d0ea 100644
--- a/src/gui/Updater.hpp
+++ b/src/gui/Updater.hpp
@@ -30,7 +30,7 @@
     class QLabel;
 #endif
 
-class Updater final : public
+class Updater : public
 #ifdef UPDATER
     QDialog
 #else
diff --git a/src/gui/VideoAdjustmentW.cpp b/src/gui/VideoAdjustmentW.cpp
index faaa52e8..1cb020ed 100644
--- a/src/gui/VideoAdjustmentW.cpp
+++ b/src/gui/VideoAdjustmentW.cpp
@@ -27,6 +27,7 @@
 
 #include <QGridLayout>
 #include <QPushButton>
+#include <QSignalMapper>
 #include <QAction>
 #include <QLabel>
 
@@ -58,8 +59,12 @@ VideoAdjustmentW::VideoAdjustmentW()
     QGridLayout *layout = new QGridLayout;
 
     m_sliders.reserve(CONTROLS_COUNT);
+    m_sliderWidgets.reserve(CONTROLS_COUNT);
     m_actions.reserve(CONTROLS_COUNT);
 
+    m_sliderMapper = new QSignalMapper(this);
+    connect(m_sliderMapper, SIGNAL(mapped(int)), this, SLOT(onSliderValueChanged(int)));
+
     for (int i = 0; i < CONTROLS_COUNT; ++i)
     {
         QLabel *titleL = new QLabel(tr(g_controlsNames[i]) + ": ");
@@ -81,26 +86,27 @@ VideoAdjustmentW::VideoAdjustmentW()
             slider->setRange(-100, 100);
         }
         slider->setWheelStep(1);
-        connect(slider, &Slider::valueChanged, this, [=](int v) {
-            const bool isGammaControl = (i == GAMMA);
-            const QString displayVal = isGammaControl
-                ? QString::number(Functions::sliderValueToGamma(v), 'f', 2)
-                : QString::number(v);
-            valueL->setText(displayVal);
-            emit videoAdjustmentChanged((isGammaControl ? tr("Gamma correction: ") : titleL->text()) + displayVal);
-        });
         slider->setValue(0);
+
+        SliderWidgets widgets;
+        widgets.slider = slider;
+        widgets.valueL = valueL;
+        widgets.titleL = titleL;
+        m_sliderWidgets.push_back(widgets);
         m_sliders.push_back(slider);
 
+        connect(slider, SIGNAL(valueChanged(int)), m_sliderMapper, SLOT(map()));
+        m_sliderMapper->setMapping(slider, i);
+
         QAction *actionDown = new QAction(this);
-        connect(actionDown, &QAction::triggered, this, [=] {
-            slider->setValue(slider->value() - g_step);
-        });
+        actionDown->setData(i); // Store slider index
+        actionDown->setProperty("direction", -1); // -1 for down
+        connect(actionDown, SIGNAL(triggered()), this, SLOT(onAdjustmentActionTriggered()));
 
         QAction *actionUp = new QAction(this);
-        connect(actionUp, &QAction::triggered, this, [=] {
-            slider->setValue(slider->value() + g_step);
-        });
+        actionUp->setData(i); // Store slider index
+        actionUp->setProperty("direction", 1); // 1 for up
+        connect(actionUp, SIGNAL(triggered()), this, SLOT(onAdjustmentActionTriggered()));
 
         m_actions.push_back({actionDown, actionUp});
 
@@ -110,13 +116,10 @@ VideoAdjustmentW::VideoAdjustmentW()
     }
 
     QPushButton *resetB = new QPushButton(tr("Reset"));
-    connect(resetB, &QPushButton::clicked, this, [this] {
-        for (int i = 0; i < CONTROLS_COUNT; ++i)
-            m_sliders[i]->setValue(0);
-    });
+    connect(resetB, SIGNAL(clicked()), this, SLOT(onResetClicked()));
 
     m_resetAction = new QAction(tr("Reset video adjustments"), this);
-    connect(m_resetAction, &QAction::triggered, resetB, &QPushButton::click);
+    connect(m_resetAction, SIGNAL(triggered()), this, SLOT(onResetClicked()));
 
     layout->addWidget(resetB, layout->rowCount(), 0, 1, 3);
     layout->addItem(new QSpacerItem(40, 0, QSizePolicy::Maximum, QSizePolicy::Minimum), layout->rowCount(), 2);
@@ -194,3 +197,39 @@ void VideoAdjustmentW::addActionsToWidget(QWidget *w)
     }
     w->addAction(m_resetAction);
 }
+
+void VideoAdjustmentW::onSliderValueChanged(int idx)
+{
+    if (idx >= 0 && idx < static_cast<int>(m_sliderWidgets.size()))
+    {
+        const SliderWidgets &widgets = m_sliderWidgets[idx];
+        const int v = widgets.slider->value();
+        const bool isGammaControl = (idx == GAMMA);
+        const QString displayVal = isGammaControl
+            ? QString::number(Functions::sliderValueToGamma(v), 'f', 2)
+            : QString::number(v);
+        widgets.valueL->setText(displayVal);
+        emit videoAdjustmentChanged((isGammaControl ? tr("Gamma correction: ") : widgets.titleL->text()) + displayVal);
+    }
+}
+
+void VideoAdjustmentW::onAdjustmentActionTriggered()
+{
+    QAction *act = qobject_cast<QAction*>(sender());
+    if (act)
+    {
+        int idx = act->data().toInt();
+        int direction = act->property("direction").toInt();
+        if (idx >= 0 && idx < static_cast<int>(m_sliders.size()))
+        {
+            Slider *slider = m_sliders[idx];
+            slider->setValue(slider->value() + direction * g_step);
+        }
+    }
+}
+
+void VideoAdjustmentW::onResetClicked()
+{
+    for (int i = 0; i < CONTROLS_COUNT; ++i)
+        m_sliders[i]->setValue(0);
+}
diff --git a/src/gui/VideoAdjustmentW.hpp b/src/gui/VideoAdjustmentW.hpp
index 980715c8..6aee7a45 100644
--- a/src/gui/VideoAdjustmentW.hpp
+++ b/src/gui/VideoAdjustmentW.hpp
@@ -26,8 +26,10 @@
 class ModuleParams;
 class QAction;
 class Slider;
+class QLabel;
+class QSignalMapper;
 
-class VideoAdjustmentW final : public QWidget
+class VideoAdjustmentW : public QWidget
 {
     Q_OBJECT
 
@@ -47,8 +49,21 @@ public:
 signals:
     void videoAdjustmentChanged(const QString &osdText);
 
+private slots:
+    void onSliderValueChanged(int idx);
+    void onAdjustmentActionTriggered();
+    void onResetClicked();
+
 private:
+    struct SliderWidgets {
+        Slider *slider;
+        QLabel *valueL;
+        QLabel *titleL;
+    };
+
     std::vector<Slider *> m_sliders;
+    std::vector<SliderWidgets> m_sliderWidgets;
     std::vector<std::array<QAction *, 2>> m_actions;
     QAction *m_resetAction = nullptr;
+    QSignalMapper *m_sliderMapper = nullptr;
 };
diff --git a/src/gui/VideoDock.cpp b/src/gui/VideoDock.cpp
index c2ab8205..a131365b 100644
--- a/src/gui/VideoDock.cpp
+++ b/src/gui/VideoDock.cpp
@@ -26,7 +26,6 @@
 #include <Functions.hpp>
 #include <SubsDec.hpp>
 
-#include <QVersionNumber>
 #include <QMouseEvent>
 #include <QFileInfo>
 #include <QMimeData>
@@ -85,45 +84,43 @@ VideoDock::VideoDock() :
     connect(&hideCursorTim, SIGNAL(timeout()), this, SLOT(hideCursor()));
     connect(&leftButtonPlayTim, SIGNAL(timeout()), QMPlay2GUI.menuBar->player->togglePlay, SLOT(trigger()));
     connect(this, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(popup(const QPoint &)));
-    connect(&iDW, &InDockW::resized, this, &VideoDock::resized);
+    // Qt4: Use SIGNAL/SLOT syntax
+    connect(&iDW, SIGNAL(resized(const QSize &)), this, SIGNAL(resized(const QSize &)));
     connect(&iDW, SIGNAL(hasCoverImage(bool)), this, SLOT(hasCoverImage(bool)));
     connect(this, SIGNAL(dockVisibilityChanged(bool)), this, SLOT(visibilityChanged(bool)));
-    connect(&QMPlay2Core, &QMPlay2CoreClass::dockVideo, this, [this](QWidget *w) {
-        iDW.setWidget(w);
-        mouseMoveEvent(nullptr);
-    });
+    // Qt4: Use helper slot instead of lambda
+    connect(&QMPlay2Core, SIGNAL(dockVideo(QWidget*)), this, SLOT(handleDockVideo(QWidget*)));
 
     canHideIDWCursor = false;
     doubleClicked = false;
 }
 
+// Qt4: Helper slot implementation
+void VideoDock::handleDockVideo(QWidget *w)
+{
+    iDW.setWidget(w);
+    mouseMoveEvent(nullptr);
+}
+
 void VideoDock::scheduleEnterEventWorkaround()
 {
-    if (QVersionNumber::fromString(qVersion()) >= QVersionNumber(5, 12, 0))
-    {
-        // Something is wrong with enter/leave events after going full screen  or maximized in some configurations since Qt 5.12.
-        // Create a new temporary widget which fills entire parent widget to trigger enter/leave events.
-        QTimer::singleShot(0, this, [this] {
-            QTimer::singleShot(0, this, [this] {
-                if (!underMouse())
-                {
-                    QWidget tmp(this);
-                    tmp.setGeometry(rect());
-                    tmp.show();
-                }
-            });
-        });
-    }
+    // Qt4: This workaround was only needed for Qt 5.12+, not needed here
 }
 void VideoDock::maybeTriggerWidgetVisibility()
 {
     if (auto w = iDW.getWidget(); w && w->property("loseHeight").isValid())
     {
         // Hide/show widget to not hide mouse cursor outside the window when native widgets are not used (workaround)
+#if QT_VERSION >= QT_VERSION_CHECK(5, 4, 0)
         QTimer::singleShot(0, w, [w] {
             w->setVisible(false);
             w->setVisible(true);
         });
+#else
+        // Qt4: Call directly since QWidget doesn't have slots for setVisible
+        w->setVisible(false);
+        w->setVisible(true);
+#endif
     }
 }
 
@@ -246,7 +243,7 @@ void VideoDock::mouseDoubleClickEvent(QMouseEvent *e)
 {
     if (e->buttons() == Qt::LeftButton)
     {
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
         QMPlay2GUI.menuBar->window->toggleFullScreen->trigger();
 #else
         // On macOS if full screen is toggled to fast after double click, mouse remains in clicked state...
@@ -301,7 +298,12 @@ void VideoDock::moveEvent(QMoveEvent *e)
 }
 void VideoDock::wheelEvent(QWheelEvent *e)
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     const auto deltaY  = e->angleDelta().y();
+#else
+    // Qt4: Use delta() which returns an int
+    const int deltaY = e->delta();
+#endif
     auto player = QMPlay2GUI.menuBar->player;
     if (deltaY != 0 && (e->buttons() & Qt::LeftButton))
         deltaY > 0 ? player->zoom->zoomIn->trigger() : player->zoom->zoomOut->trigger();
diff --git a/src/gui/VideoDock.hpp b/src/gui/VideoDock.hpp
index 3a454e4a..77fe88f5 100644
--- a/src/gui/VideoDock.hpp
+++ b/src/gui/VideoDock.hpp
@@ -26,7 +26,7 @@
 
 class QMenu;
 
-class VideoDock final : public DockWidget
+class VideoDock : public DockWidget
 {
     Q_OBJECT
 public:
@@ -52,17 +52,17 @@ private:
 
     void unsetCursor(QWidget *w);
 
-    void dragEnterEvent(QDragEnterEvent *) override;
-    void dropEvent(QDropEvent *) override;
-    void mouseMoveEvent(QMouseEvent *) override;
-    void mouseDoubleClickEvent(QMouseEvent *) override;
-    void mousePressEvent(QMouseEvent *) override;
-    void mouseReleaseEvent(QMouseEvent *) override;
-    void moveEvent(QMoveEvent *) override;
-    void wheelEvent(QWheelEvent *) override;
-    void leaveEvent(QEvent *) override;
-    void enterEvent(Q_ENTER_EVENT *) override;
-    bool event(QEvent *) override;
+    void dragEnterEvent(QDragEnterEvent *);
+    void dropEvent(QDropEvent *);
+    void mouseMoveEvent(QMouseEvent *);
+    void mouseDoubleClickEvent(QMouseEvent *);
+    void mousePressEvent(QMouseEvent *);
+    void mouseReleaseEvent(QMouseEvent *);
+    void moveEvent(QMoveEvent *);
+    void wheelEvent(QWheelEvent *);
+    void leaveEvent(QEvent *);
+    void enterEvent(Q_ENTER_EVENT *);
+    bool event(QEvent *);
 
     QTimer hideCursorTim, leftButtonPlayTim;
     InDockW iDW;
@@ -79,6 +79,8 @@ private slots:
     void updateImage(const QImage &);
     void visibilityChanged(bool);
     void hasCoverImage(bool);
+    // Qt4: Helper slot for dockVideo signal
+    void handleDockVideo(QWidget *w);
 signals:
     void resized(const QSize &size);
     void itemDropped(const QString &, bool);
diff --git a/src/gui/VideoThr.cpp b/src/gui/VideoThr.cpp
index 132f5b17..4945a7d1 100644
--- a/src/gui/VideoThr.cpp
+++ b/src/gui/VideoThr.cpp
@@ -424,9 +424,15 @@ void VideoThr::run()
 
         if (doScreenshot && !videoFrame.isEmpty())
         {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 4, 0)
             QTimer::singleShot(0, this, [=] {
                 screenshot(videoFrame);
             });
+#else
+            // Qt4: Store frame and use helper slot
+            m_screenshotFrame = videoFrame;
+            QTimer::singleShot(0, this, SLOT(handleScreenshot()));
+#endif
             doScreenshot = false;
         }
 
@@ -440,9 +446,14 @@ void VideoThr::run()
         {
             if (playC.paused && !paused)
             {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 4, 0)
                 QTimer::singleShot(0, this, [this] {
                     pause();
                 });
+#else
+                // Qt4: Use helper slot
+                QTimer::singleShot(0, this, SLOT(handlePause()));
+#endif
                 paused = true;
                 frame_timer = -1.0;
                 emit playC.updateBitrateAndFPS(-1, -1, -1.0, 0.0, interlaced); //Set real FPS to 0 on pause
@@ -463,7 +474,7 @@ void VideoThr::run()
         paused = waiting = false;
 
         Packet packet;
-        double ts = qQNaN();
+        double ts = std::numeric_limits<double>::quiet_NaN();
         if (hasVPackets && mustFetchNewPacket)
         {
             packet = playC.vPackets.fetch();
@@ -507,7 +518,7 @@ void VideoThr::run()
             Frame decoded;
             AVPixelFormat newPixelFormat = AV_PIX_FMT_NONE;
             const int bytes_consumed = dec->decodeVideo(packet, decoded, newPixelFormat, flushVideo || skipNonKey, (skip && !skipNonKey) ? ~0 : (fast >> 1));
-            ts = decoded.isTsValid() ? decoded.ts() : qQNaN();
+            ts = decoded.isTsValid() ? decoded.ts() : std::numeric_limits<double>::quiet_NaN();
             if (newPixelFormat != AV_PIX_FMT_NONE)
                 emit playC.pixelFormatUpdate(newPixelFormat);
             if (flushVideo)
@@ -568,7 +579,7 @@ void VideoThr::run()
             ts = videoFrame.ts();
         filtersMutex.unlock();
 
-        const bool tsIsNotNan = !qIsNaN(ts);
+        const bool tsIsNotNan = !std::isnan(ts);
 
         /* Subtitles */
         QMPlay2OSDList osdList;
@@ -576,7 +587,7 @@ void VideoThr::run()
         playC.subsMutex.lock();
         const double subsPts = tsIsNotNan
             ? ts - playC.subtitlesSync
-            : qQNaN()
+            : std::numeric_limits<double>::quiet_NaN()
         ;
         const bool canDeleteSubs = (deleteSubs && m_subtitles);
         auto resetSubs = [this] {
@@ -592,7 +603,7 @@ void VideoThr::run()
         }
         else if (playC.ass)
         {
-            for (auto &&sPacket : std::as_const(sPackets))
+            for (auto &&sPacket : sPackets)
             {
                 if (sDec && m_decodeToAss)
                 {
@@ -702,7 +713,7 @@ void VideoThr::run()
 
             if (tmp_time >= 1.0)
             {
-                emit playC.updateBitrateAndFPS(-1, dec->isDummyDecoder() ? -1 : round((tmp_br << 3) / (tmp_time * 1000.0)), frames / tmp_time, canSkipFrames ? framesDisplayed / framesDisplayedTime : qQNaN(), interlaced);
+                emit playC.updateBitrateAndFPS(-1, dec->isDummyDecoder() ? -1 : round((tmp_br << 3) / (tmp_time * 1000.0)), frames / tmp_time, canSkipFrames ? framesDisplayed / framesDisplayedTime : std::numeric_limits<double>::quiet_NaN(), interlaced);
                 frames = tmp_br = framesDisplayed = 0;
                 tmp_time = framesDisplayedTime = 0.0;
             }
@@ -812,10 +823,18 @@ void VideoThr::run()
                     oneFrame = canWrite = false;
                     if (!osdList.isEmpty())
                         m_subsDisplayLocker = unique_lock<std::mutex>(m_subsDisplayMutex);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 4, 0)
                     QTimer::singleShot(0, this, [=, osdList = std::move(osdList)]() mutable {
                         write(videoFrame, std::move(osdList), seq);
                         m_subsDisplayLocker = {};
                     });
+#else
+                    // Qt4: Store state and use helper slot
+                    m_writeFrame = videoFrame;
+                    m_writeOsdList = osdList; // Copy for Qt4
+                    m_writeSeq = seq;
+                    QTimer::singleShot(0, this, SLOT(handleWrite()));
+#endif
                     if (canSkipFrames && !skipNonKey)
                         ++framesDisplayed;
                 }
@@ -906,9 +925,14 @@ void VideoThr::screenshot(Frame videoFrame)
         }
 #endif
         auto imgData = reinterpret_cast<uint8_t *>(av_malloc(W * H * 4 + av_cpu_max_align()));
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         img = QImage(imgData, W, H, QImage::Format_RGB32, [](void *ptr) {
             av_free(ptr);
         }, imgData);
+#else
+        // Qt4: QImage doesn't support cleanup callback, will leak but screenshot is rare
+        img = QImage(imgData, W, H, QImage::Format_RGB32);
+#endif
         if (!imgScaler.scale(videoFrame, imgData))
             img = QImage();
     }
@@ -939,3 +963,28 @@ void VideoThr::pause()
 #endif
     writer->pause();
 }
+
+// Qt4: Helper slots - MOC needs to see declarations unconditionally
+void VideoThr::handleScreenshot()
+{
+#if QT_VERSION < QT_VERSION_CHECK(5, 4, 0)
+    screenshot(m_screenshotFrame);
+    m_screenshotFrame = Frame(); // Clear
+#endif
+}
+
+void VideoThr::handlePause()
+{
+#if QT_VERSION < QT_VERSION_CHECK(5, 4, 0)
+    pause();
+#endif
+}
+
+void VideoThr::handleWrite()
+{
+#if QT_VERSION < QT_VERSION_CHECK(5, 4, 0)
+    write(m_writeFrame, std::move(m_writeOsdList), m_writeSeq);
+    m_subsDisplayLocker = {};
+    m_writeFrame = Frame(); // Clear
+#endif
+}
diff --git a/src/gui/VideoThr.hpp b/src/gui/VideoThr.hpp
index 74281953..d42bbe37 100644
--- a/src/gui/VideoThr.hpp
+++ b/src/gui/VideoThr.hpp
@@ -29,7 +29,7 @@ extern "C" {
 class VideoWriter;
 class HWDecContext;
 
-class VideoThr final : public AVThread
+class VideoThr : public AVThread
 {
     Q_OBJECT
 
@@ -37,18 +37,18 @@ public:
     VideoThr(PlayClass &playC, const QStringList &pluginsName = {});
     ~VideoThr();
 
-    void setDec(Decoder *dec) override;
+    void setDec(Decoder *dec);
 
     std::shared_ptr<HWDecContext> getHWDecContext() const;
 
     bool videoWriterSet();
 
-    bool lock() override;
+    bool lock();
 
-    void stop(bool terminate = false) override;
+    void stop(bool terminate = false);
 
-    bool hasError() const override;
-    bool hasDecoderError() const override;
+    bool hasError() const;
+    bool hasDecoderError() const;
 
     AVPixelFormats getSupportedPixelFormats() const;
 
@@ -83,10 +83,16 @@ public:
 
     void updateSubs();
 
+private slots:
+    // Qt4: These slots must be visible to MOC unconditionally
+    void handleScreenshot();
+    void handlePause();
+    void handleWrite();
+
 private:
     inline VideoWriter *videoWriter() const;
 
-    void run() override;
+    void run();
 
 #ifdef Q_OS_WIN
     template<bool h>
@@ -113,6 +119,14 @@ private:
     QMutex filtersMutex;
     double m_subtitlesScale = 1.0;
 
+#if QT_VERSION < 0x050400
+    // Qt4: State for lambda callbacks
+    Frame m_screenshotFrame;
+    Frame m_writeFrame;
+    QMPlay2OSDList m_writeOsdList;
+    quint32 m_writeSeq;
+#endif
+
 #ifdef Q_OS_WIN
     bool m_timerPrecision = false;
 #endif
diff --git a/src/gui/Windows/PanGestureEventFilter.cpp b/src/gui/Windows/PanGestureEventFilter.cpp
index 85e66dca..3129405a 100644
--- a/src/gui/Windows/PanGestureEventFilter.cpp
+++ b/src/gui/Windows/PanGestureEventFilter.cpp
@@ -70,7 +70,7 @@ namespace UxTheme {
 
 class PanGestureEventFilterPriv final : public QObject, public QAbstractNativeEventFilter
 {
-    bool eventFilter(QObject *watched, QEvent *event) override
+    bool eventFilter(QObject *watched, QEvent *event)
     {
         if (event->type() == QEvent::Show)
         {
@@ -130,9 +130,9 @@ class PanGestureEventFilterPriv final : public QObject, public QAbstractNativeEv
     }
 
 #if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0)
-    bool nativeEventFilter(const QByteArray &eventType, void *message, qintptr *result) override
+    bool nativeEventFilter(const QByteArray &eventType, void *message, qintptr *result)
 #else
-    bool nativeEventFilter(const QByteArray &eventType, void *message, long *result) override
+    bool nativeEventFilter(const QByteArray &eventType, void *message, long *result)
 #endif
     {
         if (eventType == "windows_generic_MSG")
diff --git a/src/gui/macOS/QMPlay2MacExtensions.hpp b/src/gui/macOS/QMPlay2MacExtensions.hpp
index 8e98b99d..178fa87c 100644
--- a/src/gui/macOS/QMPlay2MacExtensions.hpp
+++ b/src/gui/macOS/QMPlay2MacExtensions.hpp
@@ -21,7 +21,7 @@
 #include <functional>
 
 class QString;
-class QWindow;
+class QWidget; // Qt4 uses QWidget instead of QWindow
 
 namespace QMPlay2MacExtensions
 {
@@ -32,5 +32,5 @@ namespace QMPlay2MacExtensions
     void registerMacOSMediaKeys(const MediaKeysCallback &fn);
     void unregisterMacOSMediaKeys();
 
-    void showSystemUi(QWindow *mainWindow, bool visible);
+    void showSystemUi(QWidget *mainWindow, bool visible); // Qt4: QWidget instead of QWindow
 }
